﻿:Class Locate
    
    ⎕ml←3 ⋄ ⎕io←1 ⋄ Fns← 'Locate' 'Replace'
    
    ∇ r←List
      :Access Shared Public
      r←⎕NS¨2⍴⊂''
      r.(Group Parse)←⊂'Files' ''
      r.Name←Fns
      r[1].Desc←'Returns where a regex string is found in files'
      r[2].Desc←'Replace occurences of regex strings by others'
    ∇
    
    ∇ r←Run(Cmd Args);ct;w
      :Access Shared Public
      r←0 0⍴''
      ct←⎕SE.SALT.Load'Utils\fileUtils -noname'
      w←⎕SE.SALTUtils.ClassFolder∘''¨⎕SE.SALT.Settings⊂'workdir'
      w←w,¨⊂' -type=dyalog -rec'
      :Select Cmd
      :Case 1⊃Fns
          w ct.showExpr¨⊂Args
      :Case 2⊃Fns
          w ct.replExpr¨⊂Args
      :EndSelect
    ∇
    
    ∇ r←Help Cmd
      :Access Shared Public
      r←''
      r,←⊂'Arg: regex string; shows where the string is found'
      r,←⊂'Arg: 2 regex strings; replace the first one by the other'
      r←r⊃⍨Fns⍳⊂Cmd
    ∇
    
    
    
:EndClass